// SPDX-License-Identifier: CC0-1.0

// SPDX-FileCopyrightText: 2020-2021 Stefan Schmidt
// SPDX-FileCopyrightText: 2021 RadWolfie
// SPDX-FileCopyrightText: 2022 Ryan Wendland


#ifndef _NTSTATUS_
#define _NTSTATUS_

#include "xboxdef.h"

#define STATUS_SUCCESS ((DWORD)0x00000000L)
#define STATUS_WAIT_0 ((DWORD)0x00000000L)
#define STATUS_ABANDONED_WAIT_0 ((DWORD)0x00000080L)
#define STATUS_USER_APC ((DWORD)0x000000C0L)
#define STATUS_ALERTED ((DWORD)0x00000101L)
#define STATUS_TIMEOUT ((DWORD)0x00000102L)
#define STATUS_PENDING ((DWORD)0x00000103L)
#define STATUS_OBJECT_NAME_EXISTS ((DWORD)0x40000000L)
#define STATUS_NO_YIELD_PERFORMED ((DWORD)0x40000024L)
#define STATUS_SEGMENT_NOTIFICATION ((DWORD)0x40000005L)
#define STATUS_GUARD_PAGE_VIOLATION ((DWORD)0x80000001L)
#define STATUS_DATATYPE_MISALIGNMENT ((DWORD)0x80000002L)
#define STATUS_BREAKPOINT ((DWORD)0x80000003L)
#define STATUS_SINGLE_STEP ((DWORD)0x80000004L)
#define STATUS_BUFFER_OVERFLOW ((DWORD)0x80000005L)
#define STATUS_NO_MORE_FILES ((DWORD)0x80000006L)
#define STATUS_NO_MORE_ENTRIES ((DWORD)0x8000001AL)
#define STATUS_UNSUCCESSFUL ((DWORD)0xC0000001L)
#define STATUS_ACCESS_VIOLATION ((DWORD)0xC0000005L)
#define STATUS_IN_PAGE_ERROR ((DWORD)0xC0000006L)
#define STATUS_INVALID_HANDLE ((DWORD)0xC0000008L)
#define STATUS_INVALID_PARAMETER ((DWORD)0xC000000DL)
#define STATUS_END_OF_FILE ((DWORD)0xC0000011L)
#define STATUS_NO_MEMORY ((DWORD)0xC0000017L)
#define STATUS_ILLEGAL_INSTRUCTION ((DWORD)0xC000001DL)
#define STATUS_ALREADY_COMMITTED ((DWORD)0xC0000021L)
#define STATUS_ACCESS_DENIED ((DWORD)0xC0000022L)
#define STATUS_BUFFER_TOO_SMALL ((DWORD)0xC0000023L)
#define STATUS_OBJECT_TYPE_MISMATCH ((DWORD)0xC0000024L)
#define STATUS_NONCONTINUABLE_EXCEPTION ((DWORD)0xC0000025L)
#define STATUS_INVALID_DISPOSITION ((DWORD)0xC0000026L)
#define STATUS_OBJECT_NAME_INVALID ((DWORD)0xC0000033L)
#define STATUS_OBJECT_NAME_NOT_FOUND ((DWORD)0xC0000034L)
#define STATUS_OBJECT_NAME_COLLISION ((DWORD)0xC0000035L)
#define STATUS_OBJECT_PATH_NOT_FOUND ((DWORD)0xC000003AL)
#define STATUS_MUTANT_NOT_OWNED ((DWORD)0xC0000046L)
#define STATUS_SEMAPHORE_LIMIT_EXCEEDED ((DWORD)0xC0000047L)
#define STATUS_ARRAY_BOUNDS_EXCEEDED ((DWORD)0xC000008CL)
#define STATUS_FLOAT_DENORMAL_OPERAND ((DWORD)0xC000008DL)
#define STATUS_FLOAT_DIVIDE_BY_ZERO ((DWORD)0xC000008EL)
#define STATUS_FLOAT_INEXACT_RESULT ((DWORD)0xC000008FL)
#define STATUS_FLOAT_INVALID_OPERATION ((DWORD)0xC0000090L)
#define STATUS_FLOAT_OVERFLOW ((DWORD)0xC0000091L)
#define STATUS_FLOAT_STACK_CHECK ((DWORD)0xC0000092L)
#define STATUS_FLOAT_UNDERFLOW ((DWORD)0xC0000093L)
#define STATUS_INTEGER_DIVIDE_BY_ZERO ((DWORD)0xC0000094L)
#define STATUS_INTEGER_OVERFLOW ((DWORD)0xC0000095L)
#define STATUS_PRIVILEGED_INSTRUCTION ((DWORD)0xC0000096L)
#define STATUS_DATA_OVERRUN ((DWORD)0xC000003CL)
#define STATUS_INVALID_IMAGE_FORMAT ((DWORD)0xC000007BL)
#define STATUS_INSUFFICIENT_RESOURCES ((DWORD)0xC000009AL)
#define STATUS_FILE_IS_A_DIRECTORY ((DWORD)0xC00000BAL)
#define STATUS_INVALID_PARAMETER_1 ((DWORD)0xC00000EFL)
#define STATUS_INVALID_PARAMETER_2 ((DWORD)0xC00000F0L)
#define STATUS_INVALID_PARAMETER_3 ((DWORD)0xC00000F1L)
#define STATUS_INVALID_PARAMETER_4 ((DWORD)0xC00000F2L)
#define STATUS_INVALID_PARAMETER_5 ((DWORD)0xC00000F3L)
#define STATUS_INVALID_PARAMETER_6 ((DWORD)0xC00000F4L)
#define STATUS_INVALID_PARAMETER_7 ((DWORD)0xC00000F5L)
#define STATUS_INVALID_PARAMETER_8 ((DWORD)0xC00000F6L)
#define STATUS_INVALID_PARAMETER_9 ((DWORD)0xC00000F7L)
#define STATUS_INVALID_PARAMETER_10 ((DWORD)0xC00000F8L)
#define STATUS_INVALID_PARAMETER_11 ((DWORD)0xC00000F9L)
#define STATUS_INVALID_PARAMETER_12 ((DWORD)0xC00000FAL)
#define STATUS_STACK_OVERFLOW ((DWORD)0xC00000FDL)
#define STATUS_CONTROL_C_EXIT ((DWORD)0xC000013AL)
#define STATUS_TOO_MANY_SECRETS ((DWORD)0xC0000156L)
#define STATUS_HANDLE_NOT_CLOSABLE ((DWORD)0xC0000235L)
#define STATUS_IMAGE_GAME_REGION_VIOLATION ((DWORD)0xC0050001L)
#define STATUS_IMAGE_MEDIA_TYPE_VIOLATION ((DWORD)0xC0050002L)

#endif

